//----------------------------------------------------------------------------
//
// Dlq - a Darklands Quest Lister
// (C) 2000 by Michael Petzold
//
//----------------------------------------------------------------------------

// Borland ObjectWindows 5.0 Library
#include <owl/statusba.h>
#include <owl/controlb.h>
#include <owl/buttonga.h>

// ANSI C Library
#include <assert.h>

// Local includes
#include "DrawWindow.h"
#include "Dlq.rc"
#include "DlqApp.h"


char error_text[1024];

// ---

void DlqApp::InitMainWindow()
{
  // Construct a TextGadget - first because we need the pointer for the DrawWindow
  // constructor.
  TTextGadget* tg = new TTextGadget(0, TTextGadget::Recessed, TTextGadget::Left, 20);

  // Construct the decorated frame window
  TDecoratedFrame* frame = new TDecoratedFrame(0, "Dlq", new DrawWindow(0, tg), true);

  // Set the initial window size
  frame->Attr.X = 75;
  frame->Attr.Y = 50;
  frame->Attr.W = 650;
  frame->Attr.H = 450;

  // Construct a status bar
  TStatusBar* sb = new TStatusBar(frame, TGadget::Recessed);

  // Insert the TextGadget into the status bar
  sb->Insert(*tg);

  // Construct a control bar
  TControlBar* cb = new TControlBar(frame, TControlBar::Vertical);
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TButtonGadget(CM_FILERELOAD, CM_FILERELOAD, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_FILEOPEN, CM_FILEOPEN, TButtonGadget::Command));
  cb->Insert(*new TButtonGadget(CM_FILESAVEAS, CM_FILESAVEAS, TButtonGadget::Command));
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TButtonGadget(CM_FILESORT, CM_FILESORT, TButtonGadget::Command));
  cb->Insert(*new TSeparatorGadget);
  cb->Insert(*new TButtonGadget(CM_ABOUT, CM_ABOUT, TButtonGadget::Command));
  cb->SetHintMode(TGadgetWindow::EnterHints);

  // Insert the status bar and control bar into the frame
  frame->Insert(*sb, TDecoratedFrame::Bottom);
  frame->Insert(*cb, TDecoratedFrame::Left);

  // Set the main window and its menu
  SetMainWindow(frame);
  GetMainWindow()->AssignMenu("COMMANDS");
  GetMainWindow()->SetIcon(this, IDI_ICON1);
  GetMainWindow()->SetIconSm(this, IDI_ICON2);
}


int OwlMain(int /*argc*/, char* /*argv*/ [])
{
  DlqApp TheApp;

  assert (sizeof(short) == 2);              // ShortKeyMask

  return TheApp.Run();
}
