//----------------------------------------------------------------------------
//
// Dlq - a Darklands Quest Lister
// (C) 2000 by Michael Petzold
//
//----------------------------------------------------------------------------

#ifndef _DRAWWINDOW_H
#define _DRAWWINDOW_H

// Borland ObjectWindows 5.0 Library
#include <owl/opensave.h>
#include <owl/textgadg.h>

#include "DlqApp.h"


static inline int HeightInPixels(int pointSize)
{
  TScreenDC  dc;
  return MulDiv(-pointSize, dc.GetDeviceCaps(LOGPIXELSY), 72);
}

// ---

class DrawWindow : public TWindow
{
  public:
    DrawWindow(TWindow* parent = 0, TTextGadget* tg = 0);
    ~DrawWindow();
    void SetupWindow();

  protected:
    MyStringArray *BodyArray; // To store lines.
    TOpenSaveDialog::TData* FileData;
    TTextGadget* StatusText;
    TSize DocSize;      // Document size in log unit
    bool DocSizeValid;
    TFont *pFont1, *pFont2;
    TRect rectUserMargins;         // user defined margins in logical units
    TSize sizeCharScn,             // screen character metrics
          sizeSpaceScn,            // between line space on screen
          sizeLineScn,             // screen  line metrics only - cx not really used
          sizeLogInch;             // size of a logical inch, in pixels
    char *GameDir;

    // override member functions of TWindow

    // message response functions
    void EvSize(uint sizeType, TSize& size);
    void EvLButtonDown(uint, TPoint&);
    void EvKeyDown(uint key, uint repeatCount, uint flags);
    void Paint(TDC&, bool, TRect&);
    void CmFileReload();
    void CmFileOpen();
    void CmFileSaveAs();
    void CmFileSort();
    void CmAbout();
    void SaveFile();
    void OpenFile();

  private:
    TSize GetDocSize();
    void AdjustScroller();
    void ComputeScreenMetrics();
    void DumpFile(const char* fnum);

    DECLARE_RESPONSE_TABLE(DrawWindow);
};

#endif
