//----------------------------------------------------------------------------
//
// Dlq - a Darklands Quest Lister
// (C) 2000 by Michael Petzold
//
//----------------------------------------------------------------------------

// Local includes
#include "DlqDump.h"
#include "FileDlg.h"


DEFINE_RESPONSE_TABLE1(FileDlg, TDialog)
  EV_COMMAND (IDOK, CmOk),
  EV_COMMAND (IDCANCEL, CmCancel),
END_RESPONSE_TABLE;


FileDlg::FileDlg(TWindow* parent, char* fnum)
  : TDialog(parent, FileDlg::IDD), FileList(this, FileDlg::IDC), FileNum(fnum)
{
  NameArray = new MyStringArray(10, 0, 10);
}


FileDlg::~FileDlg()
{
  delete NameArray;
}


void FileDlg::SetupWindow()
{
  TDialog::SetupWindow();

  if (!create_fname_array(NameArray)) {
    MessageBox(error_text, "File Error", MB_OK | MB_ICONEXCLAMATION);
    return;
  }

  MyStringIterator i(*NameArray);
  string str;

  while (i) {
    str = i++;
    FileList.AddString(str.c_str());
  }

  FileList.SetSelIndex(0);
}


void FileDlg::CmOk()
{
  char buf[10];

  if (FileList.GetSelString(buf, 11) <= 1) {
    FileNum[0] = '\0';
  }
  else {
    // The character positions here are 'one more to the right' because of the
    // leading space that is prepended in create_fname_array.
    FileNum[2] = '\0';
    FileNum[0] = buf[7];
    if (buf[8] != '.')
      FileNum[1] = buf[8];
    else
      FileNum[1] = '\0';

  }

  TDialog::CmOk();
}


void FileDlg::CmCancel()
{
  // your stuff here

  TDialog::CmCancel();
}

